    /* WNEXAMPL.C:  Simple example of Turbo C TOOLS window usage.   */

#include <bwindow.h>

int main()
{
    BWINDOW *pwin;
    BORDER  bord;
    WHERE   location;
    int     mode,columns,act_page;
    int     cursor_was_off,row,col,high,low;
    char    response[5];
    int     scan;

    /* Create the window structure in memory.			    */

    pwin = wncreate(6,		/* Height of data area		    */
		    15, 	/* Width  of data area		    */
		    SC_CYAN);	/* Attributes of data area	    */
    if (pwin == NIL)
	return b_wnerr; 	/* Quit if failure.		    */
				/* (b_wnerr records the most	    */
				/* recent window error.)	    */

    /* Choose style of border.					    */

    bord.type = BBRD_SSSS | BBRD_TCT; /* Box drawn with single	    */
				/*   lines, having a top centered   */
				/*   title.			    */
    bord.attr	 = SC_MAGENTA;	/* Border will be magenta on black. */
    bord.ttattr  = REVERSE;	/* Title will be black on white.    */
    bord.pttitle = " A Window ";/* Text of the title.               */

    /* Choose where to display the window:  the active page on	    */
    /* the current display device.				    */

    location.dev	= scmode(&mode,&columns,&act_page);
    location.page	= act_page;
    location.corner.row = 10;
    location.corner.col =  5;

    /* Retrieve former cursor position and size.		    */

    cursor_was_off = sccurst(&row,&col,&high,&low);

    /* Actually display the window				    */

    if (NIL == wndsplay(pwin,&location,&bord))
	return b_wnerr; 	/* Quit if failure.		    */

    /* Display a message on the window. 			    */

    wnprintf("Hello, world!  (Press ENTER to continue) ");
    if (b_wnerr)
	return b_wnerr; 	/* Quit if failure.		    */

    /* Await a response from the user, echoing keystrokes to the    */
    /* window.							    */

    wnquery(response,
	    sizeof(response),
	    &scan);
    if (b_wnerr)
	return b_wnerr; 	/* Quit if failure.		    */

    /* Remove the window & restore the screen and cursor.	    */

    wnremove(pwin);
    if (b_wnerr)
	return b_wnerr; 	/* Quit if failure.		    */

    sccurset(row,col);
    scpgcur(cursor_was_off,high,low,CUR_NO_ADJUST);

    return wndstroy(pwin);	/* Clean up data structures.	    */
}
