/**
*
*  BFILES.H -- Header File for C TOOLS File and Directory Functions
*
*  Version 6.00  (C)Copyright Blaise Computing Inc.  1983, 1987, 1989
*
**/

#ifndef DEF_BFILES		/* Prevent redefinition.	    */

#include <butil.h>


#define FL_DOS_INT 0x21 	/* General DOS gate interrupt.	    */

#define AT_GENERAL  0		/* File attributes		    */
#define AT_RDONLY   1
#define AT_HIDDEN   2
#define AT_SYSTEM   4
#define AT_VOLUME   8
#define AT_DIR	   16
#define AT_ARCHIVE 32

#define FL_LOCK     0		/* Constants for FLDOLOCK and	    */
#define FL_UNLOCK   1		/* FLLOCK.			    */

#define MAX_FLEN   67		/* Maximum length of filenames	    */
				/* returned by FLNORM, etc.	    */


/* Function declarations.					    */

int cdecl fllock (int, int,	    /* Lock or unlock a section of  */
		  unsigned long,    /* an open file.		    */
		  unsigned long);   /*				    */
				    /*				    */
int cdecl flprompt (const char *,   /* Accept a text response from  */
		    char *,int);    /* standard input.		    */
				    /*				    */
int cdecl fldolock (int,	    /* Intelligently lock a section */
		    unsigned long,  /* of a file.		    */
		    unsigned long,  /*				    */
		    int, int);	    /*				    */
				    /*				    */
int cdecl flflush (int);	    /* Flush buffer associated with */
				    /* a handle.		    */
				    /*				    */
int cdecl flnorm (const char *,     /* Normalize a path name (put   */
		  char *, int *);   /* into standard form)	    */
				    /*				    */
void cdecl flputdta (void far *);   /* Set the Disk Transfer Area   */
				    /*				    */
void far *cdecl flgetdta (void);    /* Return the DTA location	    */
				    /*				    */
int cdecl flretvol (int, char *,    /* Return volume label	    */
		    unsigned *,     /*				    */
		    unsigned *);    /*				    */
				    /*				    */
int cdecl flsetvol(int, 	    /* Create or alter volume label */
		   const char *);   /*				    */
				    /*				    */
int cdecl flremvol (int);	    /* Remove volume label	    */
				    /*				    */

#define DEF_BFILES   1		    /* Prevent second reading of    */
				    /* these definitions.	    */

#endif				    /* Ends "#ifndef DEF_BFILES"    */
